package com.gatedge.jindie.controller;

import com.gatedge.jindie.entity.Entity;
import com.gatedge.jindie.entity.EntityItem;
import com.gatedge.jindie.result.ActionResult;
import com.gatedge.jindie.result.ListResult;
import com.gatedge.jindie.result.ResponseBodyMessage;
import com.gatedge.jindie.result.ResultBuilder;
import com.gatedge.jindie.service.SealedQuotationService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Base64;
import java.util.List;
import java.util.Map;

/**
 * @param
 * @Author: 王康
 * @Description: TODO
 * @return
 * @DateTime: 2023/8/24 15:49
 * 描述：
 **/
@RestController
@RequestMapping("/admin/")
public class SealedQuotationController {

    private static final Logger log = LoggerFactory.getLogger(SealedQuotationController.class);
    @Autowired
    private SealedQuotationService sealedQuotationService;

    private ResponseBodyMessage responseBodyMessage;
    //记录单据编号，用于上传到单据附件管理
    private String UploadFbillNo;

    @GetMapping("login")
    public ActionResult login(@RequestParam("FBILLNO") String FBILLNO, @RequestParam("Username") String username, @RequestParam("Password") String password) {
        sealedQuotationService.login(FBILLNO, username, password);
        return ResultBuilder.buildActionSuccess();
    }

    @PostMapping("queryData")
    public ListResult queryData(@RequestBody  Map<String, String> map) {
        String FBILLNO = map.get("FBILLNO");
        List<Entity> data = null;
        if (sealedQuotationService.loginChack(map)) {
            data= sealedQuotationService.queryData(FBILLNO);
        }
        return ResultBuilder.buildEntitySuccess(data);
    }

    @PostMapping("queryDataItem")
    public ListResult queryDataItem(@RequestBody  Map<String, String> map) {
        String FBILLNO = map.get("FBILLNO");
        List<EntityItem> data = null;
        if (sealedQuotationService.loginChack(map)) {
            data= sealedQuotationService.queryDataItem(FBILLNO);
        }
        return ResultBuilder.buildEntitySuccess(data);
    }

    @PostMapping("saveData")
    public ListResult saveData(@RequestBody Map<String, Object> params) {
        Map<String, Object> map = sealedQuotationService.saveData(params);
        return ResultBuilder.buildEntitySuccess(map);
    }

    @PostMapping("/upload")
    public ResponseBodyMessage upload(@RequestParam("file") MultipartFile file,
                                      @RequestParam("FBILLNO1") String Fbillno) throws IOException {
        // 获取文件名
        String fileName = file.getOriginalFilename();
        // 获取文件内容并转换为 Base64 编码
        String fileBase64 = Base64.getEncoder().encodeToString(file.getBytes());

        System.out.println("文件名为：" + fileName);
        System.out.println("文件抓取BASE64值：" + fileBase64);
        System.out.println("单据编号 :" + Fbillno);

        // 调用服务层方法处理文件上传逻辑
        String FIDrestful = sealedQuotationService.InterId(Fbillno);
        System.out.println("文件获取FID值：" + FIDrestful);

        // 调用服务层方法上传文件
        ResponseBodyMessage responseBodyMessage = sealedQuotationService.uploadFile(FIDrestful, fileName, fileBase64, Fbillno);
        System.out.println("解析JSON数据：" + responseBodyMessage.getMessage());

        return responseBodyMessage;
    }
    @GetMapping("/CreateFile")
    public ListResult CreateFile(@RequestParam String Fbillno) {
        List<EntityItem> data = null;

        return ResultBuilder.buildEntitySuccess(data);
    }
}
