package com.gatedge.jindie.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.gatedge.jindie.entity.Entity;
import com.gatedge.jindie.entity.EntityItem;
import com.gatedge.jindie.entity.EntityVO;
import com.gatedge.jindie.entity.FileEntityItem;
import com.gatedge.jindie.result.ResponseBodyMessage;
import com.gatedge.jindie.service.SealedQuotationService;

import com.jayway.jsonpath.JsonPath;
import javafx.collections.ObservableArray;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 * @param
 * @Author: 王康
 * @Description: TODO
 * @return
 * @DateTime: 2023/8/24 15:53
 * 描述：
 **/
@Service
public class SealedQuotationServiceImpl implements SealedQuotationService {

    @Autowired
    private RestTemplate restTemplate;
    //主表
    private String Primary_Meter="Fid,FBILLNO,FProjectName,FSrcBillNo,FSupplierId.FNumber,FSupplierName,FOpenDate,FPriceStatus,FQuoteDate,FExpiryDate,FContact,FPhone,FMail,FCurrId.FName,FIsIncludedTax,FDATE,FBuyer.FName,FCheckerId,FDocumentStatus";
    private String Detailed_List="FEntity_FEntryID, FMATERIALID.FNumber,FMaterialId.FName, FUnitID.FName,FQty, FPrice, FTaxRate, FTaxPrice,FNote,FPayConditionId.FName";
    //查询表单的FID
    private String UploadPrimary_Meter = "FID";

    private String QUERY_DATA_URL="http://192.168.61.20:18081/K3CLOUD/Kingdee.BOS.WebApi.ServicesStub.DynamicFormService.ExecuteBillQuery.common.kdsvc";
    private String SAVA_DATA_URL="http://192.168.61.20:18081/k3cloud/Kingdee.BOS.WebApi.ServicesStub.DynamicFormService.Save.common.kdsvc";

    private String UploadFile = "http://192.168.61.20:18081/K3Cloud/Kingdee.BOS.WebApi.ServicesStub.DynamicFormService.Save.common.kdsvc";
    //查询单据FID的Url
    private String QueryInterId = "http://192.168.61.20:18081/K3Cloud/Kingdee.BOS.WebApi.ServicesStub.DynamicFormService.ExecuteBillQuery.common.kdsvc";
    //查询单据上传附件
    private String QueryFilesUrl = "http://192.168.61.20:18081/K3Cloud/Kingdee.BOS.WebApi.ServicesStub.DynamicFormService.ExecuteBillQuery.common.kdsvc";
    //查询单据上传附件的主键
    private String QueryFiles = "FID,FATTACHMENTNAME,FATTACHMENTSIZE,FCREATETIME";

    @Override
    public void login(String FBILLNO, String username, String password) {
        Map<String, Object> data = new HashMap<>();
        Map<String, Object> params = new HashMap<>();
        params.put("FormId", "kafe2f22a0498441f9109c31cf5586da5");
        params.put("FieldKeys", "FSupplierName,FSupplierId.FNumber");
        params.put("FilterString", "FBILLNO like'%" + FBILLNO + "'");
        params.put("OrderString", "");
        params.put("TopRowCount", "0");
        params.put("StartRow", "0");
        params.put("Limit", "100");
        data.put("data", params);
        String api = loginAPI(null);
        loginAPI(api);
        String input = API(api, data,QUERY_DATA_URL);
        if (input != null) {
            input = input.substring(2, input.length() - 2); // 截取字符串，去掉 "[[" 和 "]]"
            String[] parts = input.split(",");
            List<String> list = new ArrayList<>();
            for (String part : parts) {
                String cleanedPart = part.replaceAll("[\"\\s+]", ""); // 去掉多余的双引号和空格
                list.add(cleanedPart);
            }
            if (!list.get(0).equals(username)) {
                throw new IllegalArgumentException("供应商名称有误");
            }
            if (!list.get(1).equals(password)) {
                throw new IllegalArgumentException("供应商编号有误");
            }
        } else {
            throw new IllegalArgumentException("未找到供应商相关数据");
        }

    }

    @Override
    public List<Entity> queryData(String FBILLNO) {
        Map<String, Object> data = new HashMap<>();
        Map<String, Object> params = new HashMap<>();
        params.put("FormId", "kafe2f22a0498441f9109c31cf5586da5");
        params.put("FieldKeys", Primary_Meter);
        params.put("FilterString", "FBILLNO like'%" + FBILLNO + "'");
        params.put("OrderString", "");
        params.put("TopRowCount", "0");
        params.put("StartRow", "0");
        params.put("Limit", "100");
        data.put("data", params);
        String api = loginAPI(null);
        loginAPI(api);
        String input = API(api, data,QUERY_DATA_URL);
        List<Entity> result = new ArrayList<>();
        if (input != null) {
            input = input.substring(2, input.length() - 2); // 截取字符串，去掉 "[[" 和 "]]"
            String[] parts = input.split(",");
            List<String> list = new ArrayList<>();
            for (String part : parts) {
                String cleanedPart = part.replaceAll("[\"\\s+]", ""); // 去掉多余的双引号和空格
                list.add(cleanedPart);
            }
            Entity entity = new Entity(list.get(0),list.get(1),list.get(2),list.get(3),list.get(4),list.get(5),list.get(6),list.get(7),list.get(8),list.get(9),list.get(10),list.get(11),list.get(12),list.get(13),list.get(14),list.get(15),list.get(16),list.get(17),list.get(18));
            if (!entity.getFCheckerId().equals("0") && entity.getFDocumentStatus().equals("C")){
                entity.setStatus(false);
            }else {
                entity.setStatus(true);
            }
            result.add(entity);
        }
        return result;

    }

    @Override
    public List<EntityItem> queryDataItem(String FBILLNO) {
        Map<String, Object> data = new HashMap<>();
        Map<String, Object> params = new HashMap<>();
        params.put("FormId", "kafe2f22a0498441f9109c31cf5586da5");
        params.put("FieldKeys", Detailed_List);
        params.put("FilterString", "FBILLNO like'%" + FBILLNO + "'");
        params.put("OrderString", "");
        params.put("TopRowCount", "0");
        params.put("StartRow", "0");
        params.put("Limit", "100");
        data.put("data",params);
        String api = loginAPI(null);
        loginAPI(api);
        //业务API
        String json = API(api, data,QUERY_DATA_URL);
        List<EntityItem> result = new ArrayList<>();
        if (json != null) {
            //可能返回的是个集合，需要处理一下
            try {
                ObjectMapper objectMapper = new ObjectMapper();
                JsonNode jsonArray = objectMapper.readTree(json);
                if (jsonArray.isArray()) {
                    int FSEQ=1;
                    for (JsonNode jsonItem : jsonArray) {
                        String input = jsonItem.toString();
                        input = input.substring(1, input.length() - 1); // 截取字符串，去掉 "[[" 和 "]]"
                        String[] parts = input.split(",");
                        List<String> list = new ArrayList<>();
                        for (String part : parts) {
                            String cleanedPart = part.replaceAll("[\"\\s+]", ""); // 去掉多余的双引号和空格
                            list.add(cleanedPart);
                        }
                        EntityItem entityItem = new EntityItem(list.get(0),list.get(1),list.get(2),list.get(3),list.get(4),list.get(5),list.get(6),list.get(7),list.get(8),list.get(9));
                        entityItem.setFSEQ(String.valueOf(FSEQ));
                        FSEQ++;
                        result.add(entityItem);
                    }
                } else {
                    System.err.println("Invalid JSON array format.");
                }
            } catch (JsonProcessingException e) {
                e.printStackTrace();
            }

        }
        return result;

    }

    @Override
    public Map<String, Object> saveData(Map<String, Object> params) {
        String isAutoAdjustField = params.get("IsAutoAdjustField").toString();
        params.remove("IsAutoAdjustField");

        Map<String, Object> data = new HashMap<>();
        data.put("Creator","String");
        data.put("NeedUpDateFields",new ArrayList<>());
        data.put("IsAutoSubmitAndAudit",isAutoAdjustField);
        SimpleDateFormat simpleDateFormat=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String format = simpleDateFormat.format(new Date());
        params.put("FQuoteDate",format);
        if (isAutoAdjustField.equals("true")) {
            data.put("FIsConfirm",true);
            params.put("FConfirmDate",format);
        }
        data.put("Model",params);

        Map<String, Object> data1 = new HashMap<>();
        data1.put("FormId", "kafe2f22a0498441f9109c31cf5586da5");
        data1.put("data",data);
        String api = loginAPI(null);
        loginAPI(api);
        //业务API
        String json = API(api, data1,SAVA_DATA_URL);

        ObjectMapper objectMapper = new ObjectMapper();
        Map<String, Object> map = null;
        try {
            map = objectMapper.readValue(json, new TypeReference<Map<String, Object>>(){});
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        return map;
    }

    public String API(String apiCookie, Map<String, Object> data,String url) {
        // 设置请求头信息
        HttpHeaders headers = new HttpHeaders();
        headers.set("Content-Type", "application/json");
        headers.set("kdservice-sessionid", apiCookie);

        // 设置请求参数
        ObjectMapper objectMapper = new ObjectMapper();
        String jsonData = null;
        try {
            jsonData = objectMapper.writeValueAsString(data);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
//        String url = "http://192.168.61.20:18081/K3CLOUD/Kingdee.BOS.WebApi.ServicesStub.DynamicFormService.ExecuteBillQuery.common.kdsvc";
        HttpEntity<String> requestEntity = new HttpEntity<>(jsonData, headers);
        System.out.println(jsonData);
        // 发送POST请求
        ResponseEntity<String> responseEntity = restTemplate.exchange(url, HttpMethod.POST, requestEntity, String.class);

        // 获取返回信息
        String response = responseEntity.getBody();
        if (Objects.equals(response, "[]")) {
            return null;
        } else {
            return response;
        }

    }

    public String loginAPI(String apiCookie) {
        Map<String, Object> params = new HashMap<>();
//        params.put("acctID", "63e200975197e2");
        params.put("acctID", "639130a0cbb6ae");
        params.put("Username", "ERP1");
//        params.put("Username", "王扶民");
        params.put("Password", "888888");
        params.put("Lcid", "2052");
        // 设置请求头信息
        HttpHeaders headers = new HttpHeaders();
        headers.set("Content-Type", "application/json");
        if (apiCookie != null) {
            headers.set("kdservice-sessionid", "95db4c18-10cd-420c-a0eb-96e2ee2db7f8");
        }
        // 设置请求参数
        ObjectMapper objectMapper = new ObjectMapper();
        String jsonData = null;
        try {
            jsonData = objectMapper.writeValueAsString(params);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        String url = "http://192.168.61.20:18081/K3Cloud/Kingdee.BOS.WebApi.ServicesStub.AuthService.ValidateUser.common.kdsvc";
//        String url = "http://1.14.142.111:9090/K3Cloud/Kingdee.BOS.WebApi.ServicesStub.AuthService.ValidateUser.common.kdsvc";
        HttpEntity<String> requestEntity = new HttpEntity<>(jsonData, headers);

        // 发送POST请求
        ResponseEntity<String> responseEntity = restTemplate.exchange(url, HttpMethod.POST, requestEntity, String.class);

        HttpHeaders headersResponse = responseEntity.getHeaders();
        List<String> list = headersResponse.get("Set-Cookie");
        // 获取返回信息
        String sessionId = null;
        String str = list.get(0);
        Pattern pattern = Pattern.compile("kdservice-sessionid=(.*?);");
        Matcher matcher = pattern.matcher(str);
        if (matcher.find()) {
            sessionId = matcher.group(1);
            System.out.println(sessionId); // 输出：d57b692d-9358-4242-a6ee-553d6f6b3b4f
        }
       return sessionId;
    }

    @Override
    public Boolean loginChack(Map<String, String> paramsData) {
        String username = paramsData.get("username");
        String password = paramsData.get("password");
        String FBILLNO = paramsData.get("FBILLNO");

        Map<String, Object> data = new HashMap<>();
        Map<String, Object> params = new HashMap<>();
        params.put("FormId", "kafe2f22a0498441f9109c31cf5586da5");
        params.put("FieldKeys", "FSupplierName,FSupplierId.FNumber");
        params.put("FilterString", "FBILLNO like'%" + FBILLNO + "'");
        params.put("OrderString", "");
        params.put("TopRowCount", "0");
        params.put("StartRow", "0");
        params.put("Limit", "100");
        data.put("data", params);
        String api = loginAPI(null);
        loginAPI(api);
        String input = API(api, data,QUERY_DATA_URL);
        if (input != null) {
            input = input.substring(2, input.length() - 2); // 截取字符串，去掉 "[[" 和 "]]"
            String[] parts = input.split(",");
            List<String> list = new ArrayList<>();
            for (String part : parts) {
                String cleanedPart = part.replaceAll("[\"\\s+]", ""); // 去掉多余的双引号和空格
                list.add(cleanedPart);
            }
            if (!list.get(0).equals(username)) {
                return false;
            }
            if (!list.get(1).equals(password)) {
                return false;
            }
            return true;
        } else {
            return false;
        }
    }

    @Override
    public String InterId(String FBillNo) {
        Map<String, Object> data = new HashMap<>();
        Map<String, Object> params = new HashMap<>();
        params.put("FormId","kafe2f22a0498441f9109c31cf5586da5");
        params.put("FieldKeys",UploadPrimary_Meter);
        params.put("FilterString", "FBILLNO like'%" + FBillNo + "'");
        data.put("data", params);
        String api = loginAPI(null);
        loginAPI(api);
        String input = API(api,data,QueryInterId);
        if (input != null) {
            //截取字符串，去掉[[]]
            input = input.substring(2, input.length() - 2);
        }
        return input;
    }

    @Override
    public ResponseBodyMessage uploadFile(String FID, String fileName, String fileBase64, String FBillNo) {
        // 创建最外层的Map
        Map<String, Object> rootMap = new HashMap<>();
        // 创建内部的data Map
        Map<String, Object> dataMap = new HashMap<>();
        // 创建Model Map
        Map<String, Object> modelMap = new HashMap<>();
        // 创建FCreateMen Map
        Map<String, Object> createMenMap = new HashMap<>();
        //获取文件后缀名
        String extension = getFileExtensionWithDot(fileName);
        //获取当前时间
        LocalDateTime currentDateTime = LocalDateTime.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        String formattedDateTime = currentDateTime.format(formatter);


        createMenMap.put("FUserID", "100746");

        // 填充Model Map
        modelMap.put("FAttachmentName", fileName);//文件名
        modelMap.put("FBillType", "kafe2f22a0498441f9109c31cf5586da5");//单据类型
        modelMap.put("FInterID", FID);//单据FID
        modelMap.put("FBillNo", FBillNo);//单据编号
        modelMap.put("FAttachment", fileBase64);//文件BASE64
        modelMap.put("FFILESTORAGE", 0);
        modelMap.put("FExtName", extension);
        modelMap.put("FEntryinterId", "-1");//单据头附件
        modelMap.put("FEntrykey", " ");//单据头附近，要传一个空格
        modelMap.put("FaliasFileName", fileName);
        modelMap.put("FCreateMen", createMenMap);
        modelMap.put("FCreateTime",formattedDateTime);

        // 填充data Map
        dataMap.put("Model", modelMap);

        // 填充最外层的Map
        rootMap.put("FormId", "BOS_Attachment");
        rootMap.put("data", dataMap);
        String api = loginAPI(null);
        loginAPI(api);
        String Json =API(api,rootMap,UploadFile);
        System.out.println("22上传的："+Json);
        Boolean Success = JsonPath.read(Json,"$.Result.ResponseStatus.IsSuccess");
        if(Success){
            return new ResponseBodyMessage(1,"附件上传成功");
        }else {
            String message = JsonPath.read(Json,"$.Result.ResponseStatus.Errors[0].Message");
            return new ResponseBodyMessage(0,"附件上传失败，失败原因："+message);
        }
    }

    @Override
    public List<FileEntityItem> queryFiles(String FBillNo) {
        Map<String, Object> data = new HashMap<>();
        Map<String, Object> params = new HashMap<>();
        params.put("FormId","BOS_Attachment");
        params.put("FieldKeys",QueryFiles);
        params.put("FilterString", "FBILLNO like'%" + FBillNo + "'");
        params.put("OrderString", "");
        params.put("TopRowCount", "0");
        params.put("StartRow", "0");
        params.put("Limit", "100");
        String api = loginAPI(null);
        loginAPI(api);
        String json = API(api,data,QueryFilesUrl);
        List<FileEntityItem> result = new ArrayList<>();
        if (json != null) {
            //可能返回的是个集合，需要处理一下
            try {
                ObjectMapper objectMapper = new ObjectMapper();
                JsonNode jsonArray = objectMapper.readTree(json);
                if (jsonArray.isArray()) {
                    int FSEQ=1;
                    for (JsonNode jsonItem : jsonArray) {
                        String input = jsonItem.toString();
                        input = input.substring(1, input.length() - 1); // 截取字符串，去掉 "[[" 和 "]]"
                        String[] parts = input.split(",");
                        List<String> list = new ArrayList<>();
                        for (String part : parts) {
                            String cleanedPart = part.replaceAll("[\"\\s+]", ""); // 去掉多余的双引号和空格
                            list.add(cleanedPart);
                        }
                        FileEntityItem entityItem = new FileEntityItem(list.get(3),list.get(2),list.get(1),list.get(0));
                        //entityItem.setFSEQ(String.valueOf(FSEQ));
                        FSEQ++;
                        result.add(entityItem);
                    }
                } else {
                    System.err.println("Invalid JSON array format.");
                }
            } catch (JsonProcessingException e) {
                e.printStackTrace();
            }

        }
        return result;
    }

    /**
     * 获取文件后缀名的方法
     * @param fileName 文件名
     * @return 文件后缀名，如果没有后缀名返回 null
     */
    public static String getFileExtensionWithDot(String fileName) {
        int dotIndex = fileName.lastIndexOf(".");
        if (dotIndex != -1 && dotIndex != 0) {
            return fileName.substring(dotIndex);
        } else {
            return "";
        }
    }
}
